=== debian/changelog ===
ros-one-class-loader (0.5.0-6noble.20250531.2024) UNRELEASED; urgency=high

  * noble Append timestamp when binarydeb was built.

 -- Michael Carroll <michael@openrobotics.org>  Sat, 31 May 2025 20:24:35 +0000

ros-one-class-loader (0.5.0-0noble) noble; urgency=high

  * Declare specific boost dependencies. (#136 <https://github.com/ros/class_loader/issues/136>)
  * Contributors: Mikael Arguedas

 -- Michael Carroll <michael@openrobotics.org>  Fri, 07 Feb 2020 00:00:00 -0000

ros-one-class-loader (0.4.2-0noble) noble; urgency=high

  * Add Python 3 support to header update scripts. (#122 <https://github.com/ros/class_loader/issues/122>)
  * Set test dll runtime output to CATKIN_PACKAGE_BIN_DESTINATION on Windows. (#113 <https://github.com/ros/class_loader/issues/113>)
  * Improve warning message formatting and detail. (#108 <https://github.com/ros/class_loader/issues/108>)
  * Add export to variable in order to allow builds on Windows. (#102 <https://github.com/ros/class_loader/issues/102>)
  * Ignore warnings about import/exports when deriving from std classes on MSVC. (#116 <https://github.com/ros/class_loader/issues/116>)
  * Use #pragma message() to print out warnings in MSVC. (#114 <https://github.com/ros/class_loader/issues/114>)
  * Avoid including Poco headers globally. (#115 <https://github.com/ros/class_loader/issues/115>)
  * Make Steven! Ragnarok the maintainer (#107 <https://github.com/ros/class_loader/issues/107>)
  * Fix non-defined CMake variable (forward-port to Melodic). (#97 <https://github.com/ros/class_loader/issues/97>)
  * Contributors: James Xu, Johnson Shih, Markus Grimm, Mikael Arguedas, Robert Haschke

 -- Michael Carroll <michael@openrobotics.org>  Fri, 07 Feb 2020 00:00:00 -0000

ros-one-class-loader (0.4.1-0noble) noble; urgency=high

  * Provide std::shared_ptr interface (#95 <https://github.com/ros/class_loader/issues/95>)
  * Windows compat and style fixups (#90 <https://github.com/ros/class_loader/issues/90>)
    * add visibility macros to public functions
    * rename private namespace 'class_loader_private' to 'impl' to match ros2 branch
  * use new headers to build library (#93 <https://github.com/ros/class_loader/issues/93>)
  * Contributors: Mikael Arguedas

 -- Michael Carroll <michael@openrobotics.org>  Fri, 27 Apr 2018 00:00:00 -0000

ros-one-class-loader (0.4.0-0noble) noble; urgency=high

  * Stop checking for c++11 support (#87 <https://github.com/ros/class_loader/pull/87>)
    all Melodic targeted platforms use gnu++14 so checking and forcing -std=c++11 doesn't make sense anymore
  * [ABI breaking] use std::string references for exceptions (#86 <https://github.com/ros/class_loader/issues/86>)
  * deprecate .h headers in favor of .hpp headers (#81 <https://github.com/ros/class_loader/pull/81>)
  * provide a script with exhaustive rules for header replacement
  * comply with package format2 xsd (#83 <https://github.com/ros/class_loader/issues/83>)
  * [ABI breaking] Exceptions fixups (#82 <https://github.com/ros/class_loader/issues/82>)
    * inline exceptions
    * use throw statement rather than function
  * [linter] add nolint for global std::string used for testing (#79 <https://github.com/ros/class_loader/issues/79>)
  * use auto for all for loops iterating on vectors/maps (#78 <https://github.com/ros/class_loader/issues/78>)
  * Add systemLibraryFormat and systemLibraryPrefix functions (#77 <https://github.com/ros/class_loader/issues/77>)
  * [ABI breaking] Bring melodic-devel closer to ros2 branch (#76 <https://github.com/ros/class_loader/issues/76>)
    * comply with extra and pedantic compiler flags
    * use c++11 nullptr instead of NULL
    * make ABI breaking change for explicit constructors
    * make linters happy
    * no need to support console_bridge < 0.3.0 anymore
    * remove obsolete todo
    * add virtual destructor in test
    * vector size() returns size_t
    * simplify branching
  * [fix warnings] c++11 requires at least one argument for ... (#71 <https://github.com/ros/class_loader/issues/71>)
  * [linter] Use std::string::empty instead comparing with an empty string (#69 <https://github.com/ros/class_loader/issues/69>)
  * [linter] wrap console bridge invocation lines (#68 <https://github.com/ros/class_loader/issues/68>)
  * OSRF and not willow in licence header (#67 <https://github.com/ros/class_loader/issues/67>)
  * Contributors: David Wagner, Mikael Arguedas

 -- Michael Carroll <michael@openrobotics.org>  Thu, 15 Feb 2018 00:00:00 -0000

ros-one-class-loader (0.3.8-0noble) noble; urgency=high

  * Fix console_bridge marcos definition (#66 <https://github.com/ros/class_loader/issues/66>)
  * Style overhaul (#64 <https://github.com/ros/class_loader/issues/64>) (#62 <https://github.com/ros/class_loader/issues/62>)
  * Add copyright notice to unique_ptr_test.cpp (#65 <https://github.com/ros/class_loader/issues/65>)
  * Contributors: Maarten de Vries, Mikael Arguedas

 -- Michael Carroll <michael@openrobotics.org>  Thu, 16 Nov 2017 00:00:00 -0000

ros-one-class-loader (0.3.7-0noble) noble; urgency=high

  * switch to package format 2 (#56 <https://github.com/ros/class_loader/issues/56>)
  * remove trailing whitespaces (#55 <https://github.com/ros/class_loader/issues/55>)
  * use CONSOLE_BRIDGE_X logging macros (#52 <https://github.com/ros/class_loader/issues/52>)
  * Contributors: Mikael Arguedas, jmachowinski

 -- Michael Carroll <michael@openrobotics.org>  Thu, 27 Jul 2017 00:00:00 -0000

ros-one-class-loader (0.3.6-0noble) noble; urgency=high

  * Made changes to two locking mechanisms inside class loader core's loadLibrary() function: 1) I added a lock to the 'addClassLoaderOwnerFor...' function to protect it against a race condition with the unloadLibrary() function. 2) I also raised the loader lock to cover the whole function. Previously the check to see if a library is already loaded and the actual loading of the library was not atomic. Multiple threads could create shared library objects, for example.

